/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables;


import com.tabajara.base.Indexes;
import com.tabajara.base.Keys;
import com.tabajara.base.Public;
import com.tabajara.base.tables.records.TelefonesRecord;

import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Telefones extends TableImpl<TelefonesRecord> {

    private static final long serialVersionUID = -689090295;

    /**
     * The reference instance of <code>public.telefones</code>
     */
    public static final Telefones TELEFONES = new Telefones();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TelefonesRecord> getRecordType() {
        return TelefonesRecord.class;
    }

    /**
     * The column <code>public.telefones.telid</code>.
     */
    public final TableField<TelefonesRecord, Integer> TELID = createField("telid", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaultValue(org.jooq.impl.DSL.field("nextval('telefones_telid_seq'::regclass)", org.jooq.impl.SQLDataType.INTEGER)), this, "");

    /**
     * The column <code>public.telefones.telnumero</code>.
     */
    public final TableField<TelefonesRecord, String> TELNUMERO = createField("telnumero", org.jooq.impl.SQLDataType.VARCHAR(11), this, "");

    /**
     * The column <code>public.telefones.fkfunmatricula</code>.
     */
    public final TableField<TelefonesRecord, String> FKFUNMATRICULA = createField("fkfunmatricula", org.jooq.impl.SQLDataType.VARCHAR(30), this, "");

    /**
     * Create a <code>public.telefones</code> table reference
     */
    public Telefones() {
        this(DSL.name("telefones"), null);
    }

    /**
     * Create an aliased <code>public.telefones</code> table reference
     */
    public Telefones(String alias) {
        this(DSL.name(alias), TELEFONES);
    }

    /**
     * Create an aliased <code>public.telefones</code> table reference
     */
    public Telefones(Name alias) {
        this(alias, TELEFONES);
    }

    private Telefones(Name alias, Table<TelefonesRecord> aliased) {
        this(alias, aliased, null);
    }

    private Telefones(Name alias, Table<TelefonesRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, "");
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return Public.PUBLIC;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.TELEFONES_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<TelefonesRecord, Integer> getIdentity() {
        return Keys.IDENTITY_TELEFONES;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<TelefonesRecord> getPrimaryKey() {
        return Keys.TELEFONES_PKEY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<TelefonesRecord>> getKeys() {
        return Arrays.<UniqueKey<TelefonesRecord>>asList(Keys.TELEFONES_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<ForeignKey<TelefonesRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<TelefonesRecord, ?>>asList(Keys.TELEFONES__TELEFONES_FKFUNMATRICULA_FKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Telefones as(String alias) {
        return new Telefones(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Telefones as(Name alias) {
        return new Telefones(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Telefones rename(String name) {
        return new Telefones(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Telefones rename(Name name) {
        return new Telefones(name, null);
    }
}
